#!/usr/bin/perl
# POV-Ray will generate an error if it encounters a "degenerate cylinder" where
# the two end points are equal. This code will scan the POV-Ray files created
# by Voro++, and strip out any of these cases.
# 
# Usually, the degenerate cylinders generated by Voro++ are not actually
# degenerate in its internal representation (since the code is specifically
# structured to avoid cases like that). However, these cases are caused by the
# POV-Ray files which are generate only have coordinates specified to a limited
# number of decimal places. In a future version, it would be nice for Voro++ to
# automatically recognize and ignore these cases.

use File::Copy;

$a=0;
open A,@ARGV[0];
open B,">@ARGV[0].temp";
while (<A>) {
	m/^cylinder{<([-\.\d]+),([-\.\d]+),([-\.\d]+)>,<\1,\2,\3>,r}/?$a++:(print B);
}
print "$a cylinders stripped\n";
move("@ARGV[0].temp",@ARGV[0]);
